## Script (Python) "pay_interswitch_accept"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=
##
# $Id: pay_interswitch_accept.py 6983 2011-11-01 10:11:24Z henrik $
"""
pay online
"""
from urllib import urlencode
import logging
logger = logging.getLogger('Skins.pay_interswitch_accept')
import DateTime

if context.portal_membership.isAnonymousUser():
    return None

try:
    from Products.zdb import set_trace
except:
    def set_trace():
        pass
request = context.REQUEST
wftool = context.portal_workflow
students = context.portal_url.getPortalObject().campus.students


student_id = context.getStudentId()
student = getattr(students,student_id)

student_record = context.students_catalog.getRecordByKey(student_id)

info = {}
info['student'] = student_record
info['payment_possible'] = False
info['amount'] = ''
info['bank'] = ''
info['type_description'] = ''
info['pay_bill_to'] = ''
fulltime = student_record.mode.endswith('_ft')

info['site_id'] = '117'
info['currency_id'] = '566'
info['pay_item_id'] = '11706'

info['bank'] = ''
info['payment_possible'] = True
info['type_description'] = 'Acceptance Fee'
info['pay_bill_to'] = student_record.name
info['student_id'] = student_id
info['student_name'] = student_record.name
info['type'] = 'online'
info['status'] = 'started'
info['session_id'] = student_record.session
info['item'] = student_record.course
info['category'] = 'acceptance'
info['student_email'] = student_record.email
now = DateTime.DateTime()
info['date'] = now
info['pay_ship_to'] = "Federal University of Technology, Minna, Nigeria"
timestamp = "%d" % int(now.timeTime()*1000)
info['order_id'] = "%s%s" % (student_id[1:],timestamp)
p_id = "p%s" % timestamp


info['surcharge'] = 300

#students in faculties 'EET','ICT' and Department 'ARC' pay 25000 while others pay 20000
if student_record.faculty in ['EET','ICT'] or student_record.department in ['ARC']:
    info['acceptance_fee'] = 25000
else:
    info['acceptance_fee'] = 20000

info['amount'] = amount = info['acceptance_fee']
total_amount = 100*(info['amount'] + info['surcharge'])

if student_id is None:
    return context.REQUEST.RESPONSE.redirect("%s/srp_anonymous_view" % context.portal_url())

if not student_record.review_state in ('admitted','objection_raised'):
    return 'not allowed'

info['action'] = "https://webpay.interswitchng.com/paydirect/webpay/pay.aspx"
#info['action'] = "https://testwebpay.interswitchng.com/test_paydirect/webpay/pay.aspx"

if "payments" not in student.objectIds():
    student.invokeFactory('PaymentsFolder','payments')
    payments = getattr(student,'payments')
    d = {}
    d['Title'] = 'Payments'
    payments.getContent().edit(mapping=d)
    wftool.doActionFor(payments,'open')
else:
    payments = getattr(student,'payments')

if request.has_key('epayment'):
    return context.interswitch_form_accept(info=info)

payments.invokeFactory('Payment', p_id)
payment = getattr(payments,p_id)
wftool.doActionFor(payment,'open')
d = {}
d.update(info)
payment.getContent().edit(mapping=d)

info['callback_url'] = "%s/payments/%s/interswitch_cb?echo=%s" % (student.absolute_url(),
                                                                  p_id,
                                                                  p_id)

logger.info('%(student_id)s initiated acceptance fee payment with order_id %(order_id)s and callback url %(callback_url)s' % info)
payment_fields = (('product_id','site_id'),
                  ('site_redirect_url','callback_url'),
                  ('Currency','currency_id'),
                  ('cust_id','student_id'),
                  ('cust_id_desc','type_description'),
                  ('cust_name','student_name'),
                  ('txn_ref','order_id'),
                  ('Amount','amount'),
                  )
args = {}
for arg,field in payment_fields:
    args[arg] = info[field]


xmldict = {}
xmldict['detail_ref'] = args['txn_ref']
xmldict['department'] = student_record.department
xmldict['level'] = student_record.level
xmldict['faculty'] = student_record.faculty
xmldict['fut_amount'] = 100*amount


xmltext = """<payment_item_detail>
<item_details detail_ref="%(detail_ref)s" college="FUT Minna" department="%(department)s" faculty="%(faculty)s">
<item_detail item_id="1" item_name="FUT Minna Acceptance Fee" item_amt="%(fut_amount)s" bank_id="120" acct_num="1750005063" />
</item_details>
</payment_item_detail>""" % xmldict

info['xml_data'] = """<input type="hidden" name="xml_data" value='%s'  />""" % xmltext

args['Amount'] = "%d" % (total_amount)
args['site_name'] = "futminna.waeup.org"
args['cust_name_desc'] = "Student Name"
args['pay_item_id'] = info['pay_item_id']
args['pay_item_name'] = "FUT Minna Acceptance Fee Payments"
args['payment_params'] = 'college_split'
#args['xml_data'] = ''
#args['xml_data'] = xmltext   # info['xml_data']can be used instead
info['args'] = args

return context.goto_interswitch_form_accept(info=info)
